/* Beispiel 6.2C */
/* Zeichnen von Sinus-Kurven */

#include <graphics.h>
#include <conio.h>
#include <math.h>

const char BGI[ ]="c:\\bc\\bgi";
const int xPkte=640;
const int yPkte=200;

int xPix(float x);
int yPix(float y);
void achsenkreuz_und_ueberschrift(void);
void kurve(float amp, float fr);

int xPix(float x)
{ return x*xPkte/360;
} /* xPix */

int yPix(float y)
{ return (1-y)*yPkte/2;
} /* yPix */

void achsenkreuz_und_ueberschrift(void)
{ line(xPix(0),yPix(0),xPix(360),yPix(0));
  line(xPix(0),yPix(1),xPix(0),yPix(-1));
  moveto(80,8);
  outtext("S i n u s");
} /* achsenkreuz_und_ueberschrift */

void kurve(float amp, float fr)
{ float t=0;
  int x,y;
  moveto(xPix(0),yPix(0));

  while (t<=360.0)
  { x=xPix(t);
    y=yPix(amp*sin(t*fr*M_PI/180.0));
    lineto(x,y);
    t=t+1;
  }
} /* kurve */

void main()
{ int karte=DETECT, modus;
  initgraph(&karte,&modus,BGI);
  setcolor(getmaxcolor());
  achsenkreuz_und_ueberschrift();
  kurve(1.0, 1.0);
  kurve(1.0/3.0, 3.0);
  getch();
  closegraph();
} /* b062c */
