/* Beispiel 6.2D */
/* Zeichnen von Sinus-Kurven */
/* Automatisches Erkennen der Grafikkarte */

#include <graphics.h>
#include <conio.h>
#include <math.h>

const char BGI[ ]="c:\\bc\\bgi";
float xlo,ylo,xru,yru,fx,fy;

void init(float xo,float yo,
  float xu,float yu);
int xPix(float x);
int yPix(float y);
void achsenkreuz_und_ueberschrift(void);
void kurve(float amp, float fr);

void init(float xo,float yo,
  float xu,float yu)
{ xlo=xo;
  ylo=yo;
  xru=xu;
  yru=yu;
  fx=(getmaxx()+1)/(xru-xlo);
  fy=(getmaxy()+1)/(yru-ylo);
} /* init */

int xPix(float x)
{ return (x-xlo)*fx;
} /* xPix */

int yPix(float y)
{ return (y-ylo)*fy;
} /* yPix */

void achsenkreuz_und_ueberschrift(void)
{ line(xPix(0),yPix(0),xPix(360),yPix(0));
  line(xPix(0),yPix(1),xPix(0),yPix(-1));
  moveto(80,8);
  outtext("S i n u s");
} /* achsenkreuz_und_ueberschrift */

void kurve(float amp, float fr)
{ float t=0;
  int x,y;
  moveto(xPix(0),yPix(0));

  while (t<=360.0)
  { x=xPix(t);
    y=yPix(amp*sin(t*fr*M_PI/180.0));
    lineto(x,y);
    t=t+1;
  }
} /* kurve */

void main()
{ int karte=DETECT, modus;
  initgraph(&karte,&modus,BGI);
  init(-30, 1.2, 450, -1.2);
  setcolor(getmaxcolor());
  achsenkreuz_und_ueberschrift();
  kurve(1.0, 1.0);
  kurve(1.0/3.0, 3.0);
  getch();
  closegraph();
} /* b062d */
