// Beispiel 7.4B
/* Andere Koordinatendarstellung */
/* nderungen nur in "Ort" */
#include <graphics.h>
#include <dos.h>
#include <math.h>
const char BGI[ ]="c:\\bc\\bgi";

class Ort
{ private:
    float r,phi;
  public:
    Ort(int x,int y) {xysetzen(x,y);};
    void xysetzen(int x,int y);

    int x() {return r*cos(phi)+0.5;};
    int y() {return r*sin(phi)+0.5;};
}; // Ort

class Pixel: public Ort
{   int ff;
  public:
    Pixel(int x,int y,int f);
    void fsetzen(int f) {ff=f;};
    int f() {return ff;};
    void zeichnen(int sichtbar);
    void bewegen(int dx,int dy);
}; // Pixel

void Ort::xysetzen(int x,int y)
{ float fx=x;
  float fy=y;
  r=sqrt(fx*fx+fy*fy);
  phi=atan2(fy,fx);
} // Ort::xysetzen

Pixel::Pixel(int x,int y,int f): Ort(x,y)
{ fsetzen(f);
} // Pixel::Pixel

void Pixel::zeichnen(int sichtbar)
{ if (sichtbar) putpixel(x(),y(),f());
  else putpixel(x(),y(),getbkcolor());
} // Pixel::zeichnen

void Pixel::bewegen(int dx,int dy)
{ zeichnen(0);
  xysetzen(x()+dx,y()+dy);
  zeichnen(1);
} // Pixel::bewegen

void main()
{ int karte=DETECT,modus,i;
  initgraph(&karte,&modus,BGI);
  Pixel p(10,10,getmaxcolor());
  p.zeichnen(1);
  for (i=1;i<=150;i++)
  { p.bewegen(1,1);
    delay(100);
  }
} // b074b
