// Beispiel 7.5B
/* Polymorphie */
#include <graphics.h>
#include <dos.h>
const char BGI [ ] = "c:\\bc\\bgi";

class Ort
{ protected:
    int xx,yy;
  public:
    Ort(int x,int y) {xysetzen(x,y);};
    void xysetzen(int x,int y)
      {xx=x; yy=y;};
    int x() {return xx;};
    int y() {return yy;};
}; // Ort

class Pixel: public Ort
{ protected:
    int ff;
  public:
    Pixel(int x,int y,int f);
    void fsetzen(int f) {ff=f;};
    int f() {return ff;};
    virtual void zeichnen(int sichtbar);
    void bewegen(int dx=1,int dy=1);
}; // Pixel

class Kreis: public Pixel
{ protected:
    int rr;
  public:
    Kreis (int x,int y,
      int f=getmaxcolor(),int r=10):
      Pixel(x,y,f) { rr=r; };
    int r() {return rr;};
    virtual void zeichnen(int sichtbar);
}; // Kreis

Pixel::Pixel(int x,int y,int f): Ort(x,y)
{ fsetzen(f);
} // Pixel::Pixel

void Pixel::zeichnen(int sichtbar)
{ if (sichtbar) putpixel(x(),y(),f());
  else putpixel(x(),y(),getbkcolor());
} // Pixel::zeichnen

void Pixel::bewegen(int dx,int dy)
{ zeichnen(0);
  xysetzen(x()+dx,y()+dy);
  zeichnen(1);
} // Pixel::bewegen

void Kreis::zeichnen(int sichtbar)
{ if (sichtbar) setcolor(f());
  else setcolor(getbkcolor());
  circle(xx,yy,rr);
} // Kreis::zeichnen

void main()
{ int karte=DETECT,modus,i;
  initgraph(&karte,&modus,BGI);
  Kreis k(25,25);
  k.zeichnen(1);
  for (i=1;i<=150;i++)
  { k.bewegen(1,1);
    delay(100);
  }
} // b075b
