// Beispiel 7.7D
/* Operatoren fr Brche */

#include <iostream.h>
#include <math.h>

class Bruch
{   long z, // Zhler
	 n; // Nenner
    long ggt(long,long);
  public:
    Bruch(long z=1,long n=1)
      { Bruch::z=z;Bruch::n=n; };
    void operator=(Bruch);
    operator double()
      { return (double)z/(double)n; }
    friend Bruch operator+ (Bruch a,Bruch b);
    friend Bruch operator+ (long a,Bruch b);
    friend Bruch operator+ (Bruch a,long b);
    friend ostream& operator<<
      (ostream&,Bruch);
    friend istream& operator>>
      (istream&,Bruch&);
}; // Bruch

long Bruch::ggt(long x,long y)
{ x=abs(x);
  y=abs(y);
  for(;;)
  { int r=x % y;
    if (!r) return y;
    x=y;
    y=r;
  }
} // Bruch::ggt

Bruch operator+(Bruch a,Bruch b)
{ long
    z=a.z*b.n + b.z*a.n,
    n=a.n*b.n;
  return Bruch(z,n);
} // operator+

Bruch operator+(long a,Bruch b)
{ return Bruch(a)+b;
} // operator+

Bruch operator+(Bruch a,long b)
{ return a+Bruch(b);
} // operator+

ostream & operator<<(ostream& o,Bruch b)
{ return o << "(" << b.z << "/" << b.n << ")";
} // operator<<

istream & operator>>(istream& i,Bruch& b)
{ return i >> b.z >> b.n;
} // operator>>

void Bruch::operator=(Bruch b)
{ z = b.z;
  n = b.n;
} // operator=

void main()
{ Bruch u(2,3),v;
  cout << "Bruch-Addition:\nZhler Nenner ? ";
  cin >> v;
  cout<<u<<" + "<<v<<" = "<< u+v <<"\n";

  double d;
  d=u+3;
  cout<<"Wert von "<< u+3 <<" = "<<d<<"\n";
} // b077d

