// Beispiel 8.4B
// Berechnung von Noten aus Testergebnissen
// Verwendung von Klassen und
// Elementfunktionen

#include <iostream.h>
#include <string.h>

const int maxKatnr=40;
typedef int Punkteanz[4];

struct Name
  { char nach[16], vor[16];
  };

class Schueler
  { Punkteanz test;
  public:
    Name n;
    void lesen(void);
    int gesamtnote(void);
    int bewertung;
  }; // Schueler

typedef Schueler Klasse[maxKatnr];
void eingabe(Klasse& k,int &schanz);
void ausgabe(Klasse k,int schanz);


void Schueler::lesen(void)
{ cout << "Nachname:";
  cin.width(15);  cin >> n.nach;
  cout << "Vorname: ";
  cin.width(15);  cin >> n.vor;
  for (int j=0;j<4;j++)
  { cout << j+1 <<
      ".Test - Punkte (0...100):";
    cin >> test[j];
  }
} // Schueler::lesen

int Schueler::gesamtnote(void)
{ int n=0,j;
  for (j=0;j<4;j++)
    n+=test[j];
  n=(400-n)/50 + 1;
  return n<5 ? n : 5;
} // Schueler::gesamtnote

void eingabe(Klasse &k,int &schanz)
{ int i;
  cout <<
    "Auswertung von Tests\nSchleranzahl:";
  cin >> schanz;
  for (i=0;i<schanz;i++)
  { cout << "Katalog-Nr:" << i+1 << "\n";
    k[i].lesen();
    cout << "\n";
  }
} // eingabe

void ausgabe (Klasse k,int schanz)
{ int i;
  for (i=0;i<schanz;i++)
  { cout.width(2);
    cout << i+1 << " " << k[i].n.nach << " "
      << k[i].n.vor;
    cout.width (46-(strlen(k[i].n.nach)
      + strlen(k[i].n.vor) + 4));
    cout << k[i].gesamtnote() << '\n';
    // Die Noten werden in der 46. Spalte
    // ausgegeben
  }
} // ausgabe

void main()
{ Klasse k;
  int schanz;
  eingabe(k,schanz);
  ausgabe(k,schanz);
} // b084b
