// Beispiel 8.4C
/* Mehrere Turtles */
#include <graphics.h>
#include <dos.h>
#include <math.h>
const char BGI [ ] = "c:\\bc\\bgi";
class Ort
{ protected:
    int xx,yy;
  public:
    Ort(int x,int y) {xysetzen(x,y);};
    void xysetzen(int x,int y) {xx=x; yy=y;};
    int x() {return xx;};
    int y() {return yy;};
}; // Ort

class Pixel: public Ort
{ protected:
    int ff;
  public:
    Pixel(int x,int y,int f);
    void fsetzen(int f) {ff=f;};
    int f() {return ff;};
    void zeichnen(int sichtbar);
    void bewegen(int dx=1,int dy=1);
}; // Pixel

class Turtle: public Pixel
{ protected:
    float ww;
    int sichtbar;
  public:
    Turtle (int x=getmaxx()/2,int y=getmaxy()/2,
      int f=getmaxcolor(),int w=90):
      Pixel(x,y,f)
      { ww=w/180.0*M_PI;
	sichtbar=1;
      };
    void drehe(int dw) {ww+=dw/180.0*M_PI;};
    int w() {return ww*180.0/M_PI;};
    void gehe(int ds);
    void penup() {sichtbar=0;}
    void pendown() {sichtbar=1;};
}; // Turtle

Pixel::Pixel(int x,int y,int f): Ort(x,y),ff(f)
{ } // Pixel::Pixel

void Pixel::zeichnen(int sichtbar)
{ if (sichtbar) putpixel(x(),y(),f());
  else putpixel(x(),y(),getbkcolor());
} // Pixel::zeichnen

void Pixel::bewegen(int dx,int dy)
{ zeichnen(0);
  xysetzen(x()+dx,y()+dy);
  zeichnen(1);
} // Pixel::bewegen

void Turtle::gehe(int dw)
{ int xneu=xx+dw*cos(ww)+0.5;
  int yneu=yy+dw*sin(ww)+0.5;
  if (sichtbar)
  { setcolor(f());
    line(xx,yy,xneu,yneu);
  }
  xx=xneu;
  yy=yneu;
} // Turtle::gehe

void main()
{ int karte=DETECT,modus,i,j;
  initgraph(&karte,&modus,BGI);
  Turtle t[20];
  for (i=0;i<=19;i++) t[i].drehe(i*18);
  for (j=1;j<=20;j++)
  { for (i=0;i<=19;i++)
    { t[i].gehe(10);
      t[i].drehe(10);
    }
    delay(500);
  }
} // b084c
