/* Beispiel 9.2 */
/* Ein- und Ausgabe von Zahlenwerten */

#include <stdio.h>
#include <conio.h>

void schreiben(char ausdatname[ ]);
void lesen(char eindatname[ ]);
void mischen(void);

void schreiben(char ausdatname[ ])
{ int wert;
  FILE *ausdat;
  ausdat=fopen(ausdatname,"w");
  while (scanf("%d",&wert)>0)
    fwrite(&wert,sizeof(wert),1,ausdat);
  fclose(ausdat);
} /* schreiben */

void lesen(char eindatname[])
{ int wert;
  FILE *eindat;
  eindat=fopen(eindatname,"r");
  if (eindat==NULL)
  { printf("Fehler beim ffnen von %s\n",
      eindatname);
    return;
  }
  while (fread(&wert,sizeof(wert),1,eindat)>0)
    printf("%8d\n",wert);
  fclose(eindat);
} /* lesen */

void mischen(void)
{ FILE *file1,*file2,*file3;
  int wert1,wert2;
  int eof1,eof2,lies1,lies2;
  file1=fopen("DATEN2A","rb");
  file2=fopen("DATEN2B","rb");
  file3=fopen("DATEN2C","wb");
  lies1=1;
  lies2=1;

  for (;;)
  { if (lies1)
    { eof1=fread(&wert1,sizeof(wert1),1,file1)<=0;
      lies1=0;
    }
    if (lies2)
    { eof2=fread(&wert2,sizeof(wert2),1,file2)<=0;
      lies2=0;
    }
    if (eof1 && eof2)
      break;
    if ((wert1<wert2 || eof2) && !eof1)
      { fwrite(&wert1,sizeof(wert1),1,file3);
        lies1=1;
      }
    else
      { fwrite(&wert2,sizeof(wert2),1,file3);
        lies2=1;
      }
  }
  fclose(file1);
  fclose(file2);
  fclose(file3);
} /* mischen */

void main()
{ char antwort;
  char dateiname[41];
  printf("Schreiben/Lesen einer Datei\n"
    "Abbruch beim Schreiben mit <STRG>Z\n");
  do
  { printf("S(chreiben), L(esen), "
      "M(ischen), E(nde) :");
    antwort=toupper(getch());
    printf("%c\n",antwort);
    switch (antwort)
    { case 'L':
	printf("(Lesen) Dateiname: ");
	scanf("%40s",dateiname);
	lesen(dateiname);
	break;
      case 'S':
	printf("(Schreiben) Dateiname: ");
	scanf("%40s",dateiname);
	schreiben(dateiname);
	break;
      case 'M':
	mischen();
	break;
    }
  } while (antwort!='E');
} /* b092 */
