// Beispiel 10.2C
/* Liste mit int-Daten */

#include <stdlib.h>
#include <iostream.h>

class Liste;
typedef Liste *PListe;
class Liste
{ public:
    PListe n; // nchstes
    Liste() { n=NULL; };
    virtual ~Liste() { };
    void einf_vorne(PListe p);
    void einf_hinten(PListe p);
    virtual void drucke();
}; // Liste

void Liste::einf_vorne(PListe p)
{ (*p).n=n;
  n=p;
} // Liste::einf_vorne

void Liste::einf_hinten(PListe p)
{ if(!n) n=p;
  else
  { PListe h=n;
    while (h->n) h=h->n;
    h->n=p;
  }
} // Liste::einf_hinten

void Liste::drucke()
{ cout << "Fehler: Liste.drucke();\n";
  exit(1);
} // Liste::drucke

class IntEl;
typedef IntEl *PIntEl;
class IntEl:public Liste
  { int e;
  public:
    IntEl(int ee) { e=ee; };
    virtual void drucke();
  }; // IntEl

void IntEl::drucke()
{ cout.width(5);
  cout << e;
} // IntEl::drucke

void main()
{ Liste l;
  int i;
  PListe p;
  for (i=1; i<=10; i++)
  { p=new IntEl(i);
    l.einf_hinten(p);
  }

  p=l.n;
  while(p)
  { p->drucke();
    p=p->n;
  }
  cout << '\n';
} // b102c
