// Beispiel 10.3A
/* Doppelt verkette Liste mit int-Daten */

#include <stdlib.h>
#include <iostream.h>

class Liste;
typedef Liste *PListe;
class Liste
{ public:
    PListe n; // nchstes
    Liste() { n=NULL; };
    virtual ~Liste() { };
    void einf_vorne(PListe p);
    virtual void drucke();
}; // Liste

void Liste::einf_vorne(PListe p)
{ (*p).n=n;
  n=p;
} // Liste::einf_vorne

void Liste::drucke()
{ cout << "Fehler: Liste.drucke();\n";
  exit(1);
} // Liste::drucke

// --- Bis hierher wie im Beispiel b102b ---

class DListe;
typedef DListe *PDListe;
class DListe:public Liste
{   PDListe v; // vorheriges
  public:
    DListe():Liste() { v=NULL; };
    int leer() { return n==NULL; };
    void einf_vorne(PDListe p);
    void einf_hinten(PDListe p);
}; // DListe

void DListe::einf_vorne(PDListe p)
{ if (leer()) v=p;
  else ((PDListe)n)->v=p;
  // Typenkonversion von n ist notwendig!
  p->n=n;
  n=p;
  p->v=NULL;
} // DListe::einf_vorne

void DListe::einf_hinten(PDListe p)
{ if (leer()) n=p;
  else v->n=p;
  p->v=v;
  v=p;
  p->n=NULL;
} // DListe::einf_hinten

// -- IntEl wird nun von DListe abgeleitet,
//    alles andere wie im Beispiel b102b --

class IntEl;
typedef IntEl *PIntEl;
class IntEl: public DListe
{   int e;
  public:
    IntEl(int e) { IntEl::e=e; };
    virtual void drucke();
}; // IntEl

void IntEl::drucke()
{ cout.width(5);
  cout << e;
} // IntEl::drucke

void main()
{ DListe l;
  int i;
  PDListe p;
  for (i=1; i<=5; i++)
  { p=new IntEl(i);
    l.einf_vorne(p);
  }
  for (i=6; i<=10; i++)
  { p=new IntEl(i);
    l.einf_hinten(p);
  }

  p=(PDListe)l.n;
  while(p)
  { p->drucke();
    p=(PDListe)(p->n);
  }
} // b103a
