// Beispiel 10.3B
/* Doppelt verkette Liste */

#include <stdlib.h>
#include <iostream.h>

class Liste;
typedef Liste *PListe;
class Liste
{ public:
    PListe v; // vorheriges
    PListe n; // nchstes
    Liste() { v=(n=NULL); };
    virtual ~Liste() { };
    int leer() { return n==NULL; };
    int anzahl();
    void einf_vorne(PListe p);
    void einf_hinten(PListe p);
    virtual void drucke();
}; // Liste

int Liste::anzahl()
{ if (leer()) return 0;
  else return n->anzahl() + 1;
} // Liste::anzahl

void Liste::einf_vorne(PListe p)
{ if (leer()) v=p;
  else n->v=p;
  p->n=n;
  n=p;
  p->v=NULL;
} // Liste::einf_vorne

void Liste::einf_hinten(PListe p)
{ if (leer()) n=p;
  else v->n=p;
  p->v=v;
  v=p;
  p->n=NULL;
} // Liste::einf_hinten

void Liste::drucke()
{ cout << "Fehler: Liste.drucke();\n";
  exit(1);
} // Liste::drucke

class IntEl;
typedef IntEl *PIntEl;
class IntEl: public Liste
{   int e;
  public:
    IntEl(int e) { IntEl::e=e; };
    virtual void drucke();
}; // IntEl

void IntEl::drucke()
{ cout.width(5);
  cout << e;
} // IntEl::drucke

class FloatEl;
typedef FloatEl *PFloatEl;
class FloatEl: public Liste
{   float e;
  public:
    FloatEl(float e) { FloatEl::e=e; };
    virtual void drucke();
}; // FloatEl

void FloatEl::drucke()
{ cout.width(5);
  cout << e;
} // FloatEl::drucke

void main()
{ Liste l;
  int i;
  PListe p;
  for (i=1; i<=5; i++)
    l.einf_vorne(new IntEl(i));
  for (i=6; i<=10; i++)
    l.einf_hinten(new FloatEl(i));

  cout << "\n" << l.anzahl() << " Elemente:\n";
  p=l.n;
  while(p)
  { p->drucke();
    p=p->n;
  }
} // b103b
