// Beispiel 12.11A
/* Typ-Identifikation, Typ-Konversion */

#include <iostream.h>
#include <typeinfo.h>

void main()
{ const int *zki;
  const int ki=3;
  zki = &ki;
  cout << "zki zeigt auf " << *zki << endl;   // 3
  cout << "ki ist " << ki << endl;            // 3
  // zi=zki;   geht nicht, wohl aber:
  int *zi = static_cast <int* > (zki);
  *zi = 6;
  cout << "zki zeigt auf " << *zki << endl;   // 5
  cout << "ki ist " << ki << endl;            // 3
  cout << typeid(zi).name() << endl;

  long l = reinterpret_cast <long> (zki);
  cout << "Adresse zki " << l << endl;

  enum WoTag { Mo, Di, Mi, Do, Fr, Sa, So } ;
  WoTag t = WoTag(3);
  WoTag t2 = static_cast <WoTag> (4);

  class __rtti X
  { virtual void f(void){};
  };
  class __rtti Y : public X { } ;
  class __rtti Z : public Y { } ;

  X x, *zx;
  Y y, *zy;
  Z z;
  zx = &x; cout << typeid(zx).name() << endl; // *X
  zx = &y; cout << typeid(zx).name() << endl; // *X
  zx = static_cast <Y*> (&y); cout << typeid(zx).name() << endl; // *X
  zx = dynamic_cast <Y*> (&y); cout << typeid(zx).name() << endl; // *X

  zy = &y; cout << typeid(zy).name() << endl;  // *Y
  // zy = &x; cout << typeid(zy).name() << endl; geht nicht.
  // jedoch:

  cout << "zx: ";
  zx = dynamic_cast <X*> (&x);  // X mu polymorph sein, sonst Fehler
  if (zx) cout << typeid(zx).name() << endl;// *X
  else cout << "Fehler bei Konversion \n";

  cout << "zy: ";
  zy = dynamic_cast <Y*> (&x);  // X mu polymorph sein, sonst Fehler
  if (zy) cout << typeid(zy).name() << endl;
  else cout << "Fehler bei Konversion \n";  // Fehlermeldung

  cout << typeid(x).name() << " before " ;  // nicht in einer cout-Anw.
  cout << typeid(y).name() << ": " ;
  cout << (typeid(x).before(typeid(y)) ? "wahr" : "falsch") << endl;//w

  cout << typeid(x).name() << " before " ;  // nicht in einer cout-Anw.
  cout << typeid(z).name() << ": " ;
  cout << (typeid(x).before(typeid(z)) ? "wahr" : "falsch") << endl;//w

  cout << typeid(Y).name() << " before " ;
  cout << typeid(X).name() << ": " ;
  cout << (typeid(Y).before(typeid(X)) ? "wahr" : "falsch") << endl;//f
} // B1211A
