// Beispiel 12.4B
/* Lesen einer Taste */

#include <bios.h>
#include <stdio.h>
#include <ctype.h>

void main()
{ int taste,umschalt;
  printf("Tasten einlesen, Ende mit <ESC>\n");
  do
  { /* Warten, bis eine Taste gedrckt wird: */
    while(bioskey(1)==0);

    /* Taste und Umschalttaste lesen: */
    taste=bioskey(0);
    umschalt=bioskey(2);

    /* Gedrckte Taste anzeigen: */
    printf("bioskey(1): %04x, Scan-Code: %02X, ",
      taste,taste>>8);

    /* Oberes Byte auf 0 setzen: */
    taste &= 0xFF;
    printf("ASCII: %02X,",taste);
    if (isalnum(taste)) printf("'%c' ",taste);

    /* Status der Umschalttasten */
    if (umschalt & 0x80) printf ("Ins ");
    if (umschalt & 0x40) printf ("CapsLock ");
    if (umschalt & 0x20) printf ("NumLock ");
    if (umschalt & 0x10) printf ("ScrollLock ");
    if (umschalt & 0x08) printf ("Alt ");
    if (umschalt & 0x04) printf ("Ctrl ");
    if (umschalt & 0x02)
      printf ("Shift(links) ");
    if (umschalt & 0x01)
      printf ("Shift(rechts) ");
    printf("\n");
  } while (taste!=0x1B);
} // b124b
