// Beispiel 12.5A
// Aufruf von BIOS-Interrupts
/* Beispiel: INTR 17 (hex):
   Abfrage des Druckerstatus */

#include <iostream.h>
#include <dos.h>

#define status(s,m) if (ausgabe.h.ah & s)\
  cout << m

void main()
{ REGS eingabe,ausgabe;
  eingabe.h.ah=0x02;  // Wahl der Funktion
  eingabe.x.dx=0x0000;	// LPT1=0, LPT2=1, ...
  int86(0x17, &eingabe, &ausgabe);// Aufruf
  status(0x80,"Bereit. ");
  status(0x40,"ACK-Signal bernommen. ");
  status(0x20,"Kein Papier. ");
  status(0x10,"Drucker ON-Line. ");
  status(0x08,"Ein/Ausgabefehler. ");
  status(0x01,"Time-Out. ");
} // b125a
