// Anfang der Datei bgi_oo.h = b131a.h
#include <graphics.h>
#define CLIP_ON 1

class Graphik
{
protected:
  // Ntzlich Variablen im gewhlten
  // Videomode
  static unsigned
    x_max_vm,
      // Bildschirmauflsung x-Richtung
    y_max_vm,
      // Bildschirmauflsung y-Richtung
    farbanzahl_vm, // Anzahl der Farben
    x_mitte_vm, // Bildschirmmittelpkt-Koordinaten
    y_mitte_vm;
  static int initialisiert;
public:
  virtual float x_abb(float x);
  virtual float y_abb(float y);
  virtual float x_invabb(float x);
  virtual float y_invabb(float y);
  unsigned x_max() { return x_max_vm; };
  unsigned y_max() { return y_max_vm; };
  unsigned farbanzahl()
    { return farbanzahl_vm; };
  unsigned x_mitte(){ return x_mitte_vm; };
  unsigned y_mitte() { return y_mitte_vm; };

  int xPix(float x);
  int yPix(float y);
  float xKoord(int xfenster);
  float yKoord(int yfenster);

  Graphik(char *bgi_pfad="",
    int treiber=DETECT,int modus=0);
  virtual ~Graphik();
  void warte_auf_taste();
  void bgi_end();
}; // Graphik

class Screen: public Graphik
{
protected:
  int x_ursprung,y_ursprung;
public:
  Screen(int xur,int yur,int farbe=getbkcolor());
  void achsen(unsigned farbe);
  virtual float x_abb(float x);
  virtual float y_abb(float y);
  virtual float x_invabb(float x);
  virtual float y_invabb(float y);
}; // Screen

class Fenster: public Screen
{ // ntzliche Informationen ber die Welt
  // und das Fenster
  float x_weite_welt,y_weite_welt;
  int x_weite_fenster,y_weite_fenster;
  float x_abbfaktor,y_abbfaktor;
  int x_absflo,y_absflo,x_absfru,y_absfru;
public:
  Fenster
    (float xwlo,float ywlo,
    float xwru,float ywru,
    int xflo,int yflo,int xfru,int yfru,
    int bkfarbe,int rfarbe);
  void fensteraktiv();

  virtual float x_abb(float x);
  virtual float y_abb(float y);
  virtual float x_invabb(float x);
  virtual float y_invabb(float y);
  void achsen(float xmin,float xmax,
    float ymin,float ymax,unsigned farbe);
}; // Fenster

// Ende der Datei bgi_oo.h = b131a.h
