// Beispiel 13.1B
#include "b131a.h"

const char BGI [ ] = "c:\\bc\\bgi";

void main()
{ char far *meldung=
    "Weiter mit beliebiger Taste";

  // Instanz der Klasse Screen
  Graphik g(BGI);
  Screen s(10,s.y_mitte(),LIGHTGRAY);
  int sp,ep;
  s.achsen(BLUE);
  setcolor(WHITE);
  // Erste Graphik:
  for (sp=0;sp<=20;sp++)
    for (ep=0;ep<=20;ep++)
      line(s.xPix(sp*30),s.yPix(150),
	s.xPix(ep*30),s.yPix(-150));

  outtextxy(s.xPix(5),s.xPix(5),meldung);
  s.warte_auf_taste();

  // Instanz f1 der Klasse fenster
  Fenster f1
    (-1,10,5,-1,320,20,620,180,GREEN,WHITE);
  f1.achsen(-0.5,4.5,-0.5,9.5,YELLOW);
  setfillstyle(SLASH_FILL,RED);
  // Die Weltkoordinaten des Punktes (0,4.3) werden
  // mit xPix, yPix in die Fensterkoordinaten
  // umgerechnet
  bar3d(f1.xPix(0),f1.yPix(4.3),
	f1.xPix(1),f1.yPix(0),20,1);
  settextjustify(LEFT_TEXT,BOTTOM_TEXT);
  outtextxy(f1.xPix(-1),f1.yPix(-1),meldung);
  f1.warte_auf_taste();

  // Instanz f2 der Klasse fenster
  Fenster f2
  (-10,10,10,-10,100,230,620,390,RED,WHITE);
  setcolor(BLUE);
  settextjustify(CENTER_TEXT,BOTTOM_TEXT);
  settextstyle(SANS_SERIF_FONT,HORIZ_DIR,4);
  outtextxy(f2.xPix(0),f2.yPix(2),
    "Zweites Fenster aktiv");
  f2.achsen(-1,1,-1,1,GREEN);
  line(f2.xPix(-5), f2.yPix( 0),
       f2.xPix( 0), f2.yPix(-5));
  line(f2.xPix( 0), f2.yPix(-5),
       f2.xPix( 5), f2.yPix( 0));
  settextjustify(LEFT_TEXT,BOTTOM_TEXT);
  settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
  outtextxy(f2.xPix(-10),f2.yPix(-10),
    meldung);
  f2.warte_auf_taste();

  // Instanz f3 der Klasse fenster
  Fenster f3
  (-30,20,30,-20,80,10,280,210,BLUE,WHITE);

  // Alle Pixels des Fensters durchlaufen
  int y,x,farbe,z_wert;
  float x_welt,y_welt;
  for (y=1;y<=199;y++)
    for (x=1;x<=199;x++)
    { // Weltkoordinaten des Pixels bestimmen
      x_welt=f3.xKoord(x);
      y_welt=f3.yKoord(y);

      // z=F(x,y) berechnen
      z_wert=x_welt*x_welt + y_welt*y_welt;

      // dem Funktionswert eine Farbe zuweisen
      farbe=z_wert % 16;
      // Pixel einfrben
      putpixel(x,y,farbe);
    }

  setcolor(DARKGRAY);
  outtextxy(f3.xPix(-20),f3.yPix(15),meldung);
  f3.warte_auf_taste();

  // Fenster f1 reaktivieren
  f1.fensteraktiv();

  // Graphik fertigstellen
  setcolor(BLACK);
  // Achtung: BLACK ist die aktuelle Farbe
  // Hintergrundfarbe derzeit LIGHTGRAY !!

  setfillstyle(INTERLEAVE_FILL,YELLOW);
  bar3d(f1.xPix(1), f1.yPix(3.5),
	f1.xPix(2), f1.yPix(0), 20, 1);
  setfillstyle(LINE_FILL,WHITE);
  bar3d(f1.xPix(2), f1.yPix(2.2),
	f1.xPix(3), f1.yPix(0), 20, 1);
  s.warte_auf_taste();
  s.bgi_end();    // Ende des Graphikmodus
} // b131b.cpp
