// Anfang der Datei maus_oo.h = b133a.h

struct MAkt
  { int tastenStatus,aktionen,xPos,yPos;
  }; // MAkt

struct Gcursor
  { unsigned screenMaske[16],cursorMaske[16];
    int xHot,yHot;
  }; // Gcursor

const int keineTaste=0;
const int linkeTaste=1;
const int rechteTaste=2;
const int beideTasten=3;

const int Hardware=1;
const int Software=0;

const int abfrageLinks=0;
const int abfrageRechts=1;

const Gcursor hand=
  { { 0xe1ff,0xe1ff,0xe1ff,0xe1ff,
      0xe1ff,0xe000,0xe000,0xe000,
      0x0000,0x0000,0x0000,0x0000,
      0x0000,0x0000,0x0000,0x0000 },
    { 0x1e00,0x1200,0x1200,0x1200,
      0x1200,0x13ff,0x1249,0x1249,
      0xf249,0x9049,0x9001,0x8001,
      0x8001,0x8001,0x8001,0xffff },
    5,0
  };

const Gcursor kreuz=
  { { 0xfeff,0xfeff,0xfeff,0xfeff,
      0xfeff,0xfeff,0xfeff,0x0001,
      0xfeff,0xfeff,0xfeff,0xfeff,
      0xfeff,0xfeff,0xfeff,0xfeff },
    { 0x0100,0x0100,0x0100,0x0100,
      0x0100,0x0100,0x0100,0xfffe,
      0x0100,0x0100,0x0100,0x0100,
      0x0100,0x0100,0x0100,0x0100 },
    7,7
  };

class Maus
{   int xx,yy;
  protected:
    int sichtbar;
  private:
    int MausnotOK;
  public:
    Maus();
    int notOK();

    virtual int xWo(int);
    virtual int yWo(int);
    virtual int xInvWo(int);
    virtual int yInvWo(int);
    void pos(int& xpos,int& ypos,int &taste);

    int x();
    int y();
    int t();
    void setzen(int xpos,int ypos);
    void zeigen(int wahl);
    void tasteDruck(int taste,MAkt& mp);
    void tasteLos(int taste,MAkt& mp);
    void grenzen(int x1,int y1,int x2,int y2);
    int innen(int x1,int y1,int x2,int y2);
}; // Maus

class GMaus: public Maus
{ public:
    GMaus();
    void cursor(Gcursor);
}; // GMaus

class TMaus: public Maus
{ public:
    TMaus();
    virtual int xWo(int);
    virtual int yWo(int);
    virtual int xInvWo(int);
    virtual int yInvWo(int);
    void cursor(unsigned ctyp,
      unsigned sMaske,unsigned cMaske);
}; // TMaus

// Ende der Datei maus_oo.h = b133a.h
