// Beispiel 7.4C
/* Zwei Punkte gleichzeitig */
/* Verwendung von "protected" */
#include <graphics.h>
#include <dos.h>
const char BGI[ ]="c:\\bc\\bgi";

class Ort
{ protected:
    int xx,yy;
  public:
    Ort(int x,int y) {xysetzen(x,y);};
    void xysetzen(int x,int y)
      {xx=x; yy=y;};

    int x() {return xx;};
    int y() {return yy;};
}; // Ort

class Pixel: public Ort
{   int ff;
  public:
    Pixel(int x,int y,int f=getmaxcolor());
    void fsetzen(int f) {ff=f;};
    int f() {return ff;};
    void zeichnen(int sichtbar);
    void bewegen(int dx=1,int dy=1);
}; // Pixel

Pixel::Pixel(int x,int y,int f): Ort(x,y)
{ fsetzen(f);
} // Pixel::Pixel

void Pixel::zeichnen(int sichtbar)
{ if (sichtbar) putpixel(xx,yy,ff);
  else putpixel(xx,yy,getbkcolor());
} // Pixel::zeichnen

void Pixel::bewegen(int dx,int dy)
{ zeichnen(0);
  xysetzen(x()+dx,y()+dy);
  zeichnen(1);
} // Pixel::bewegen

void main()
{ int karte=DETECT,modus,i;
  initgraph(&karte,&modus,BGI);
  Pixel p(10,10,3), q(300,10);
  p.zeichnen(1);
  q.zeichnen(1);
  for (i=1;i<=150;i++)
  { p.bewegen();
    q.bewegen(-1,1);
    delay(100);
  }
} // b074c
