// Beispiel 7.7A
/* Rechenoperationen fr Brche */

#include <iostream.h>
#include <math.h>

class Bruch
{   long z, // Zhler
	 n; // Nenner
    long ggt(long,long);
  public:
    Bruch(long z=1,long n=1)
      { Bruch::z=z;Bruch::n=n; };
    Bruch add (Bruch b);
    void ausgabe();
}; // Bruch

long Bruch::ggt(long x,long y)
{ x=abs(x);
  y=abs(y);
  for(;;)
  { int r=x % y;
    if (!r) return y;
    x=y;
    y=r;
  }
} // Bruch::ggt

Bruch Bruch::add(Bruch b)
{ long nn=n*b.n;
  long zz=z*b.n + b.z*n;
  long t=ggt(zz,nn);
  return Bruch(zz/t,nn/t);
} // Bruch::operator+

void Bruch::ausgabe()
{ cout << "(" << z << "/" << n << ")";
} // Bruch::ausgabe

void main()
{ Bruch u(2,3),v,w;
  long z,n;
  cout << "Bruch-Addition:\nZhler Nenner ? ";
  cin >> z >> n;
  v=Bruch(z,n);
  w=u.add(v);
  u.ausgabe();  cout << " + ";
  v.ausgabe();  cout << " = ";
  w.ausgabe();  cout << "\n";

  v=3; // entspricht: v=Bruch(3);
  u.ausgabe();  cout << " + ";
  v.ausgabe();  cout << " = ";
  u.add(v).ausgabe();  cout << "\n";

  w=u.add(3);
  u.ausgabe();  cout << " + ";
  Bruch(3).ausgabe();  cout << " = ";
  w.ausgabe();  cout << "\n";

  // nicht mglich:  w=3+u;
  // da auch w=3.add(u); unmglich ist
  w=Bruch(3).add(u);
  Bruch(3).ausgabe();  cout << " + ";
  u.ausgabe();  cout << " = ";
  w.ausgabe();  cout << "\n";
} // b077a

