// Beispiel 7.7C
/* Operatoren fr Brche */

#include <iostream.h>
#include <math.h>

class Bruch
{   long z, // Zhler
	 n; // Nenner
    long ggt(long,long);
  public:
    Bruch(long z=1,long n=1)
      { Bruch::z=z;Bruch::n=n; };
    friend Bruch operator+ (Bruch a,Bruch b);
    friend ostream& operator<< (ostream&,Bruch);
    friend istream& operator>> (istream&,Bruch&);
    void operator=(Bruch);
}; // Bruch

long Bruch::ggt(long x,long y)
{ x=abs(x);
  y=abs(y);
  for(;;)
  { int r=x % y;
    if (!r) return y;
    x=y;
    y=r;
  }
} // Bruch::ggt

Bruch operator+(Bruch a,Bruch b)
{ long
    z=a.z*b.n + b.z*a.n,
    n=a.n*b.n;
  return Bruch(z,n);
} // operator+

ostream & operator<<(ostream& o,Bruch b)
{ return o << "(" << b.z << "/" << b.n << ")";
} // operator<<

istream & operator>>(istream& i,Bruch& b)
{ return i >> b.z >> b.n;
} // operator>>

void Bruch::operator=(Bruch b)
{ long t=ggt(b.z,b.n);
  z = b.z/t;
  n = b.n/t;
} // operator=


void main()
{ Bruch u(2,3),v,w;
  cout << "Bruch-Addition:\nZhler Nenner ? ";
  cin >> v;
  w=u+v; // entspricht: w=operator+(u,v);
  cout << u << " + " << v << " = " << w << "\n";

  v=3; // entspricht: v=Bruch(3);
  cout << u << " + " << v << " = " << u+v << "\n";
  cout << u << " + " << v << " = " << u+3 << "\n";
  cout << u << " + " << v << " = " << 3+u << "\n";
} // b077c

