/* Beispiel 9.4B */
/* Ein- und Ausgabe von Zahlenwerten */

#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <fcntl.h>

void schreiben(char ausdatname[ ]);
void lesen(char eindatname[ ]);
void mischen(void);

void schreiben(char ausdatname[ ])
{ int wert;
  int ausdat;
  ausdat=open(ausdatname,
    O_CREAT | O_BINARY | O_RDWR);
  while (scanf("%d",&wert)>0)
    write(ausdat,&wert,sizeof(wert));
  close(ausdat);
} /* schreiben */

void lesen(char eindatname[ ])
{ int wert;
  int eindat;
  eindat=open(eindatname,
    O_BINARY | O_RDONLY);
  if (eindat==-1)
  { printf("Fehler beim ffnen von %s\n",
      eindatname);
    return;
  }
  while (read(eindat,&wert,sizeof(wert))>0)
    printf("%8d\n",wert);
  close(eindat);
} /* lesen */

void mischen(void)
{ int file1,file2,file3;
  int wert1,wert2;
  int eof1,eof2,lies1,lies2;
  file1=open("DATEN4A",O_BINARY | O_RDONLY);
  file2=open("DATEN4B",O_BINARY | O_RDONLY);
  file3=open("DATEN4C",
    O_BINARY | O_TRUNC | O_RDWR | O_CREAT);
  lies1=1;
  lies2=1;

  for (;;)
  { if (lies1)
    { eof1=
	read(file1,&wert1,sizeof(wert1))==0;
      lies1=0;
    }
    if (lies2)
    { eof2=
	read(file2,&wert2,sizeof(wert2))==0;
      lies2=0;
    }
    if (eof1 && eof2)
      break;
    if ((wert1<wert2 || eof2) && !eof1)
      { write(file3,&wert1,sizeof(wert1));
        lies1=1;
      }
    else
      { write(file3,&wert2,sizeof(wert2));
        lies2=1;
      }
  }

  close(file1);
  close(file2);
  close(file3);
} /* mischen */

void main()
{ char antwort;
  char dateiname[41];
  printf("Schreiben/Lesen einer Datei\n"
    "Abbruch beim Schreiben mit <STRG>Z\n");
  do
  { printf("S(chreiben), L(esen), "
      "M(ischen), E(nde) :");
    antwort=toupper(getch());
    printf("%c\n",antwort);
    switch (antwort)
    { case 'L':
	printf("(Lesen) Dateiname: ");
	scanf("%40s",dateiname);
	lesen(dateiname);
	break;
      case 'S':
	printf("(Schreiben) Dateiname: ");
	scanf("%40s",dateiname);
	schreiben(dateiname);
	break;
      case 'M':
	mischen();
	break;
    }
  } while (antwort!='E');
} /* b094b */
