// Beispiel 9.7B
/* Anderer Eingabeoperator fr Brche */

#include <iostream.h>
#include <math.h>

class Bruch
{   long z, // Zhler
	 n; // Nenner
    long ggt(long,long);
  public:
    Bruch(long z=1,long n=1)
      { Bruch::z=z;Bruch::n=n; };
    operator double()
      { return (double)z/(double)n; }
    friend Bruch operator+ (Bruch a,Bruch b);
    friend Bruch operator+ (long a,Bruch b);
    friend Bruch operator+ (Bruch a,long b);
    friend ostream& operator<<
      (ostream&,Bruch);
    friend istream& operator>>
      (istream&,Bruch&);
    void operator=(Bruch);
}; // Bruch

long Bruch::ggt(long x,long y)
{ x=abs(x);
  y=abs(y);
  for(;;)
  { int r=x % y;
    if (!r) return y;
    x=y;
    y=r;
  }
} // Bruch::ggt

Bruch operator+(Bruch a,Bruch b)
{ long
    z=a.z*b.n + b.z*a.n,
    n=a.n*b.n;
  return Bruch(z,n);
} // operator+

Bruch operator+(long a,Bruch b)
{ return Bruch(a)+b;
} // operator+

Bruch operator+(Bruch a,long b)
{ return a+Bruch(b);
} // operator+

ostream & operator<<(ostream& o,Bruch b)
{ return o <<"("<< b.z <<"/"<< b.n <<")";
} // operator<<

istream & operator>>(istream& i,Bruch& b)
{ long z,n;
  i >> z;
  if(!i) return i;
  char ch;
  i >> ch;
  if ((ch!='/')||(!i))
  { i.clear(ios::failbit);
    return i;
  }
  if (!(i>>n)) return i;
  b = Bruch(z,n);
  return i;
} // operator>>

void Bruch::operator=(Bruch b)
{ long t=ggt(b.z,b.n);
  z = b.z/t;
  n = b.n/t;
} // operator=


void main()
{ Bruch u(2,3),v;
  cout << "Bruch-Addition:\nZhler/Nenner ? ";
  cin >> v;
  cout<<u<<" + "<<v<<" = "<<(u+v)<<"\n";
  double d=u+v;
  cout<<"Wert von "<<(u+v)<<" = "<<d<<"\n";
} // b097b

