// Beispiel 11.3F
/* Doppelt verkette Liste mit int-Daten */

#include <iostream.h>
#include "b113e.h"

class DListe;
typedef DListe *PDListe;
class DListe:public Liste
{   PDListe v; // vorheriges
  public:
    DListe(void):Liste() { v=NULL; };
    int leer(void) { return n==NULL; };
    void einf_vorne(PDListe p);
    void einf_hinten(PDListe p);
}; // DListe

void DListe::einf_vorne(PDListe p)
{ if (leer()) v=p;
  else ((PDListe)n)->v=p;
  // Typenkonversion von n ist notwendig!
  p->n=n;
  n=p;
  p->v=NULL;
} // DListe::einf_vorne

void DListe::einf_hinten(PDListe p)
{ if (leer()) n=p;
  else v->n=p;
  // Typenkonversion von v ist notwendig!
  p->v=v;
  v=p;
  p->n=NULL;
} // DListe::einf_hinten

// -- IntEl wird nun von DListe abgeleitet,
//    alles andere wie im Beispiel b102b --

class IntEl;
typedef IntEl *PIntEl;
class IntEl: public DListe
{   int e;
  public:
    IntEl(int e) { IntEl::e=e; };
    virtual void drucke(void);
}; // IntEl

void IntEl::drucke(void)
{ cout.width(5);
  cout << e;
} // IntEl::drucke

void main()
{ DListe l;
  int i;
  PDListe p;
  for (i=1; i<=5; i++)
  { p=new IntEl(i);
    l.einf_vorne(p);
  }
  for (i=6; i<=10; i++)
  { p=(PDListe)(new IntEl(i));
    l.einf_hinten(p);
  }

  p=(PDListe)l.n;
  while(p)
  { p->drucke();
    p=(PDListe)(p->n);
  }
} // b113f
