// Beginn der Datei b113g.cpp

#include <stdlib.h>
#include <iostream.h>
#include "b113g.h"

void fehler(char *mldg)
{ cout << "\nFehler: " << mldg << "\n";
} // fehler

int Liste::anzahl(void)
{ if (leer()) return 0;
  else return n->anzahl() + 1;
} // Liste::anzahl

PListe Liste::xtes_vorw(int x)
{ PListe p=erstes();
  while (x-- >1 && p) p=p->n;
  return p;
} // PListe::xtes_vorw

PListe Liste::xtes_rueckw(int x)
{ PListe p=letztes();
  while (x-- >1 && p) p=p->v;
  return p;
} // PListe::xtes_rueckw

void Liste::einf_vorne(PListe p)
{ if (leer()) v=p;
  else n->v=p;
  p->n=n;
  n=p;
  p->v=0;
} // Liste::einf_vorne

void Liste::einf_hinten(PListe p)
{ if (leer()) n=p;
  else v->n=p;
  p->v=v;
  v=p;
  p->n=0;
} // Liste::einf_hinten

void Liste::einf_vor(PListe p,PListe wo)
{ if(!wo) einf_hinten(p);
  else
    if (!(wo->v)) einf_vorne(p);
    else
    { p->v=wo->v;
      p->n=wo;
      wo->v->n=p;
      wo->v=p;
    }
} // Liste::einf_vor

void Liste::einf_nach(PListe p,PListe wo)
{ if(!wo) einf_vorne(p);
  else
    if (!(wo->n)) einf_hinten(p);
    else
    { p->n=wo->n;
      p->v=wo;
      wo->n->v=p;
      wo->n=p;
    }
} // Liste::einf_nach

void Liste::entf(PListe was)
{ if (!was) return;
  if (was->v)
  { was->v->n=was->n;
    if (was->n)
      was->n->v=was->v;
    else
      v=was->v; // kein Nachfolger
  }
  else // erstes Element:
  { n=was->n;
    if (was->n)
      was->n->v=0;
  }
  delete(was);
} // Liste::entf

void Liste::drucke(void)
{ fehler("Fehler: Liste.drucke();");
  exit(1);
} // Liste::drucke

void Liste::aktion_vorw(PrListe was)
{ PListe p=n;
  while(p)
  { was(p);
    p=p->n;
  }
} // Liste::aktion_vorw

void Liste::aktion_rueckw(PrListe was)
{ PListe p=v;
  while(p)
  { was(p);
    p=p->v;
  }
} // Liste::aktion_rueckw

void IntEl::drucke(void)
{ cout.width(5);
  cout << e;
} // IntEl::drucke

void FloatEl::drucke(void)
{ cout.width(5);
  cout << e;
} // FloatEl::drucke

// Ende der Datei b113g.cpp
