// Beispiel 12.10
/* Exceptions */

#include <iostream.h>

void p0()
{ cout << "Programm p0\n";
  throw 1;
}

void p1()
{ cout << "Programm p1\n";
  throw 1.111;
}

void p2() throw (int)
{ cout << "Programm p2\n";
  throw 2;
}

void p3() throw (int, char*)
{ cout << "Programm p3\n";
  p2();
  throw "Hallo p3"; // nicht ausgefhrt!
}

void p4() throw ()
{ cout << "Programm p4\n";
  // throw 4;   "Program aborted"
}

typedef void (*P)();
P p[] = {p0, p1, p2, p3, p4};

void main()
{ cout << "Beginn des Programms\n";
  for (int i=0; i<=4; i++)
  { try
    { p[i]();
    }
    catch (int)
    { cout << "int-Zweig\n";
    }
    catch (char *)
    { cout << "char-Zweig\n";
    }
    catch (...)
    { cout << "Sonstiges catch\n";
    }
  }
  cout << "Ende des Programms\n";
} // b1210

