// Beispiel 12.11B
/* Typ-Identifikation, Typ-Konversion

#include <iostream.h>
#include <typeinfo.h>

class Base1
{ virtual void f(void) {};
  public:
	 int i1;
	 Base1 () {i1=11;};
}; // Base1

class Base2
{ public:
	 int i2;
	 Base2 () {i2=22;};
}; // Base2

class Derived : public Base1, public Base2 {};

int main (void)
{ int i=3;
  do
	 cout << "Test\n";
  while (--i);

  enum Tag {Mo,Di,Mi,Do,Fr,Sa,So};
  Tag t;
  t=(Tag)2;
  if (t==Mi) cout << "Tag Mi ok " << endl;
  t=Tag(3);
  if (t==Do) cout << "Tag Do ok " << endl;
  t=static_cast<Tag>(4);
  if (t==Fr) cout << "Tag Fr ok " << endl;
  cout << int(t) << endl;

  try
  { Derived d, *pd;
	 Base1 *b1, B1;


//	 pd = &d;	  b1 = pd;  // geht!

	 b1 = &B1;//  pd = b1;  // geht nicht!
				 //  pd = dynamic_cast<Derived *>(b1);  // geht nicht
	 b1 = &d; //  pd = b1;  // geht nicht, wohl aber:
					  pd = dynamic_cast<Derived *>(b1);
	 if (pd)
		cout << "Typ pd " << typeid(pd).name() << endl;//Derived
	 else
		throw Bad_cast();
	 cout << "a " << pd->i1 << "  " << pd->i2 << endl;
	 cout << "b " << b1->i1 << "  " /*<< b1->i2*/ << endl;
	 // Alternative:
	 cout << "c " << b1->i1 << "  " << ((Derived *)b1)->i2 << endl;


	 b1 = &B1; // pd = dynamic_cast<Derived *>(b1);  // geht nicht!
	 cout << "d " << b1->i1 << "  " << /*b1->i2 << */ endl;

	 Base2 *b2;
	 b1 = &d; //  b2 = b1;  geht nicht, wohl aber:
					  b2 = dynamic_cast<Derived *>(b1);
	 if (b2)
		cout << "Typ b2 " << typeid(b2).name() << endl;// Base2
	 else
		throw Bad_cast();
	 cout << "e " /*<< b2->i1 */ << "  " << b2->i2 << endl;
  }

  catch (Bad_cast)
  { cout << "Dynamic Cast milungen" << endl;
	 return 1;
  }

  catch (...)
  { cout << "Exeption-Fehler " << endl;
	 return 2;
  }

  return 0;
} // B1211B

