/* Beispiel 12.5A1 */
/* Aufruf von BIOS-Interrupts */
/* Beispiel: INTR 17 (hex):
   Abfrage des Druckerstatus */
/* Alternative: Verwendung von intr */

#include <stdio.h>
#include <dos.h>

#define status(s,m) if (reg.r_ax & s) printf(m)

void main()
{ REGPACK reg;
  reg.r_ax=0x0200;  /* Wahl der Funktion */
  reg.r_dx=0x0000;	/* LPT1=0, LPT2=1, ... */
  intr(0x17, &reg);	/* Aufruf */
  status(0x8000,"Bereit. ");
  status(0x4000,"ACK-Signal bernommen. ");
  status(0x2000,"Kein Papier. ");
  status(0x1000,"Drucker ON-Line. ");
  status(0x0800,"Ein/Ausgabefehler. ");
  status(0x0100,"Time-Out. ");
} // b125a1